library Project1;

uses
  SysUtils,
  Classes,
  IniFiles;

  type
  TColor = -$7FFFFFFF-1..$7FFFFFFF;

const
  _FileOptions  = '..\Bin\Options.ini';
  _HelpFile     = '..\Bin\Help.txt';
  _FNF          = 'File not found: ';

  _DefCommandPromt = '>';
  _FigthingCommandPromt = '';
  _DefaultName  = '';
  _Name         = ': ';
  _Status       = ': ';
  _Healt        = ': ';
  _WeaponName   = ': ';
  _WeaponDamage = '  : ';

  _Many         = ': ';
  _Goods        = '%d) %s, %d ';
  _Damage       = ': ';
  _FightWin     = 'OK ,   )';
  _FightLost    = '    8(';
  _FigthNone    = '     ?  !'; //
  _Death        = '';
  
  _GameOver     = '=== , GAME OVER :[ ===';

  _NewStatus    = 'O!    ';
  _Hello        = '  ';
  _Bonus        = ': ';

  _MsgNewGame   = '  ?   !';
  _MsgStartGame = '===   ===';
  _MsgNoComp    = '  ?   ...';
  _MsgCompNeedFigth  = '!  .   .      ;)';
  _MsgCompNeedFigth2 = ',   ';
  _MsgCompGoOut = ' .     ...';
  _MsgUserGoOut = ' . !';
  _MsgNoDrunk   = '   !';
  _MsgDrunkUp   = '  "%s" (%d )';
  _MsgDrunk     = '"%s" (%d )';
  _MsgThing     = '%s (+%d  )';
  _MsgClothes   = '%s (-%d  )';
  _MsgNothing   = ' ';
  _MsgRename    = '    ';
  _MsgInvalidCommand = '    :  ""';

  _MsgStealOK   = ' ,    %d   ';
  _MsgStealWarning   = '  , !';
  _MsgStealNO   = '  ';
  _MsgStealNOMany = ' ';

  _MsgBuyNoMany   = '  ';
  _MsgBuyOK       = 'OK,   %s';
  _MsgBuyAlreadyExists = '    ';

   TStatus    : array[0..2] of string = ('','','');
   TCompNames : array[0..3] of string = ('','','',' ');
   TWeapons   : array[0..3] of string = (' ,  ,  ','','','');
   TBonus     : array[0..1] of string = ('','');
   TBonusEx   : array[0..1] of string = ('',   '');
   TShoop_    : array[0..2] of string = ('','',' ""');
   TDrunk_    : array[0..2] of string = (' ""','','');
   TThing_    : array[0..2] of string = ('  ','  "Nike"','   ');
   Clothes_   : array[0..2] of string = (' Aidepas','  Boss',' Adidas');

   _Normal  = TColor($FFFFFF);  //clWhite
   _OK      = TColor($008000);  //clGreen
   _Warning = TColor($0000FF);  //clRed
   _Info    = TColor($00FFFF);  //clYellow


type
  ThingType = (ttThing,ttWeapon,ttDrunk,ttClothes {});
  TThing  = record  // 
    Name:string;
    Typeof:ThingType;// 
    Value:Byte;    // 
    Cout:Byte;     // 
    price:Byte; // 
  end;
  TUser = record
    Name:string;
    Status:Byte;
    healt:Byte;    // 
    weapon:TThing;// 
    Thing:array of TThing;
    Many:Byte;
    Cout:Byte; //   
    FightFactor:Byte; //  "" -  ,     (max - 100)
    StealFactor:Byte; //  
  end;

type
  TShoop = record
    Name:string;   //   ,  :)
    Data:array [0..2] of TThing;
    Tag: Byte;
    Active : boolean; //   ,   )
  end;

var
  User,Computer:TUser;
  Shoop:TShoop;
  GameRun:Boolean;
  FigthRun:Boolean;//
  _CommandPromt:String;

function GetCommandPromt:string;export;
begin
if _CommandPromt = '' then _CommandPromt:=_DefCommandPromt;
if (FigthRun and GameRun) then _CommandPromt:=_FigthingCommandPromt+_DefCommandPromt else  _CommandPromt:=_DefCommandPromt;
if Shoop.Active then _CommandPromt:=PChar(Shoop.Name+_DefCommandPromt);
result:=_CommandPromt;
end;

function Help(s:TStringList):integer;export;
begin
s.Clear;
result:=_Info;
try
s.LoadFromFile(_HelpFile);
except
s.Add(_FNF+_HelpFile);
end;
end;

function GetInfo(u:TUser;s:TStringList;InfoEx:Boolean):Integer;  //InfoEx -   - , 
var
  i:integer;
begin
if not GameRun then begin
result:=_Warning;
s.Add(_MsgNewGame);
exit;
end;
result:=_Info;
s.Add(_Name+PChar(u.Name));
s.Add(_Status+TStatus[u.Status]+Format(' (%d/%d)',[u.Status,High(TStatus)]));
s.Add(_Healt+IntToStr(u.healt));
s.Add(_WeaponName + u.weapon.Name + Format(' (%d/%d)',[u.weapon.Value,High(TWeapons)]));
s.Add(_WeaponDamage + IntToStr(u.weapon.Value));
if InfoEx then begin
//s.Add(_Beer+IntToStr(u.Beer));
s.Add(_Many+IntToStr(u.Many));
//if High(u.Thing)>0 then
for i:=0 to High(u.Thing) do begin
case u.Thing[i].Typeof of
  ttDrunk:   s.Add(Format(_MsgDrunk,[u.Thing[i].Name,u.Thing[i].Cout]));
  ttThing:   s.Add(Format(_MsgThing,[u.Thing[i].Name,u.Thing[i].Value]));
  ttClothes: s.Add(Format(_MsgClothes,[u.Thing[i].Name,u.Thing[i].Value]));
end;
end;
end;
{
if High(u.Drink)>0 then
for i:=1 to High(u.Drink) do begin
s.Add(Format(_MsgDrunk,[u.Drink[i].Name,u.Drink[i].litre]));
end;
s.Add(_Many+IntToStr(u.Many));
end;
}
end;

function GetUserInfo(s:TStringList):integer;export;
begin
s.Clear;
result:=GetInfo(User,s,true);
end;

function GetCompInfo(s:TStringList):integer;export;
begin
s.Clear;
if GameRun and (Computer.healt=0) then
begin
  result:=_Normal;
  s.Add(_MsgNothing);
  exit;
end;
result:=GetInfo(Computer,s,false);
end;

function AddBonus(s:TStringList):integer;
var
  i,y:byte;
begin
case random(High(TBonus)) of
0:begin
  i:=random(High(TDrunk_));
  y:=random(2);
  if y=0 then exit; // 0 
  setlength(user.Thing,Length(user.Thing)+1);
  user.Thing[High(user.Thing)].Cout:=y;
  user.Thing[High(user.Thing)].Name:=PChar(TDrunk_[i]);
  user.Thing[High(user.Thing)].Typeof:=ttDrunk;
  case i of
  0: user.Thing[High(user.Thing)].Value:=2; //' ""'
  1: user.Thing[High(user.Thing)].Value:=7; //''
  2: user.Thing[High(user.Thing)].Value:=9; //''
  end;
  s.Add(_Bonus+user.Thing[High(user.Thing)].Name);
  //inc(user.Beer,i);
  //s.Add(_Bonus+TBonus[0]+Format('- %d'+TBonusEx[0],[i]));
  end;
1:begin // -     )
  inc(user.Many,computer.Many);
  s.Add(_Bonus+TBonus[1]+TBonusEx[1]);
  end;
end;
end;

function Fight():integer;
var
  i,r1,r2:integer;
begin
//result:=_Normal;
randomize;
r1:=0;
r2:=0;
for i:=1 to user.weapon.Value do inc(r1,Random(i));
for i:=1 to computer.weapon.Value do inc(r2,Random(i));

for i:=0 to High(user.Thing) do

  case user.Thing[i].Typeof of
  ttThing:   begin
             inc(r1,user.Thing[i].Value);//   
             end;
  ttClothes: begin
             if user.Thing[i].Value>r2 then r2:=0 else //    
             dec(r2,user.Thing[i].Value);//   
             end;
  end;

case (r1>r2) of
true:   begin  //  
        if  computer.healt < (r1-r2) then computer.healt:=0 else
        dec(computer.healt,(r1-r2));
        //dec(user.healt,random(1)); //   :)
        result:=_Ok;
        end;
false:  begin  //  
        if  user.healt < (r2-r1) then user.healt:=0 else
        dec(user.healt,(r2-r1));
        //dec(computer.healt,random(1));
        result:=_Warning;
        end;
{
else
     if Random(10)=5 then begin    //   :)
        dec(user.healt,computer.weapon.Value); result:=_Warning end else begin
        dec(computer.healt,user.weapon.Value); result:=_Ok end;
     end;
}
end;
end;

function Fighting(s:TStringList):integer;export;
var
  d1,d2:byte; //
begin
s.Clear;
if (user.healt = 0) or (not GameRun) then  begin
result:=_Warning;
s.Add(_MsgNewGame);
Exit;
end;
if (computer.healt = 0) and GameRun then begin
result:=_Normal;
s.Add(_MsgNoComp);
FigthRun:=False;
Exit;
end;

FigthRun:=True;
//        ,    
//   (  ),    
if (computer.healt<(user.healt div 2)) and (computer.FightFactor<user.FightFactor) then begin
  if random(1)=1 then begin
  computer.healt:=0;
  s.Add(_MsgCompGoOut);
  result:=_Info;
  exit;
  end;
//   
end else dec(computer.FightFactor,random(computer.Status));

d1:=User.healt;
d2:=Computer.healt;
Result:=Fight(); // 
d1:=d1 - user.healt;
d2:=d2 - computer.healt;


if (d1=0) and (d2=0) then begin
s.Add(_FigthNone);
result:=_Normal;
end else begin
case (d1<d2) of
True:   s.Add(Format(_FightWin,[user.Name]));
False:  s.Add(user.Name+' '+_FightLost);
else begin
     s.Add(_FigthNone);
     result:=_Normal;
     end;
end;
//             :         ?             :          ?
s.Add(user.Name+' '+_Damage + inttostr(d1)+','+_Healt+IntToStr(user.healt));
s.Add(computer.Name+' '+_Damage + inttostr(d2)+','+_Healt+IntToStr(computer.healt));

end;

if (user.healt<=0) or (user.healt>150) then begin
s.Add(user.Name+' '+_Death);
s.Add(_GameOver);
GameRun:=False;
end;

if computer.healt<=0 then begin //  
  s.Add(computer.Name+' '+_Death);
  inc(user.Cout,1); //  
  AddBonus(s); //  - 
  FigthRun:=False; //  
    if user.Cout>=10 then  begin
    inc(user.Status,1);
    user.Cout:=0;
    s.Add(_NewStatus+TStatus[user.Status]);
    end;
end;
end;

function Going(s:TStringList):integer;export;
begin
s.Clear;
result:=_Normal;

if (user.healt = 0) or (not GameRun) then begin
result:=_Warning;
s.Add(_MsgNewGame);
exit;
end;

if FigthRun and (computer.healt>0) then begin
s.Add(_MsgCompNeedFigth2);
exit;
end;

randomize;

if Shoop.Active then Shoop.Active:=false;

//    ,   
if computer.healt>0 then
if Random(Computer.FightFactor)<(user.FightFactor div 2) then begin
  if random(1)=0 then begin
  computer.healt:=0;
  s.Add(_MsgUserGoOut);
  result:=_Warning;
  FigthRun:=False;
  Exit;
  end;
end else begin
FigthRun:=True;
s.Add(_MsgCompNeedFigth);
Exit;
end;

if (Random(6)<>Random(7)) then begin
computer.healt:=0;//   :)     Fighting and GetCompInfo
s.Add(_MsgNothing);
result:=_Normal;
FigthRun:=False;
exit;
end;


{
if (computer.healt>0) and (Random(Computer.FightFactor + user.FightFactor)>=user.FightFactor) and FigthRun then begin
s.Add(_MsgCompNeedFigth); //   
FigthRun:=True; // ,      ...
exit;
end;
}


Computer.Name:=TCompNames[random(High(TCompNames))];
Computer.Status:=Random(user.Status)+Random(user.Status);
Computer.healt:=Random(user.healt);
Computer.FightFactor:=Random(user.FightFactor);
if Computer.healt<=10 then Computer.healt:=Random(30);
Computer.weapon.Value:=Random(user.weapon.Value+2);
Computer.weapon.Name:=TWeapons[Computer.weapon.Value];
Computer.Many:=random(5);
s.Add(_Hello+Computer.Name);

end;

function NewGame(s:TStringList;Name:string):integer;export;
var
  s_:PChar;
begin
s.Clear;
s_:=StrAlloc(1024);
s_:=StrPCopy(s_,Name);
if Name='' then User.Name:=_DefaultName else
User.Name:=s_;
StrDispose(s_);

User.Status:=0;
User.healt:=30;
User.weapon.Value:=2;
User.weapon.Name:=TWeapons[User.weapon.Value];
setlength(user.Thing,0);
User.FightFactor:=50;
User.StealFactor:=0;
GameRun:=true;
user.Many:=5;
computer.healt:=0;
FigthRun:=False;

s.Add(_MsgStartGame);
GetInfo(User,s,true);
result:=_Normal;
end;

function DrinkBeer(s:TStringList):integer;export;
var
  a,b,i:integer;
  str:string;
begin
s.Clear;
if (user.healt = 0) or (not GameRun) then begin
result:=_Warning;
s.Add(_MsgNewGame);
exit;
end;

if user.Thing=nil then begin
    s.Add(_MsgNoDrunk);
    result:=_Warning;
    exit;
    end;

for i:=0 to High(user.Thing) do
  if user.Thing[i].Typeof=ttDrunk then begin
  a:=user.Thing[High(user.Thing)].Cout;
  b:=user.Thing[High(user.Thing)].Value;
  str:=user.Thing[High(user.Thing)].Name;
  s.Add(Format(_MsgDrunkUp,[str,a]));
  inc(user.healt,a * b);
  SetLength(user.Thing,High(user.Thing));
  result:=_Info;
  end else
    if i=High(user.Thing) then begin
    s.Add(_MsgNoDrunk);
    result:=_Warning;
    end;

end;

function Rename(s:TStringList;Name:string):integer;export;
var
  Old:string;
  s_:PChar;
begin
s.Clear;
result:=_Info;
if not GameRun then begin
result:=_Warning;
s.Add(_MsgNewGame);
exit;
end;

if Name='' then begin
//result:=_Info;
s.Add(_MsgInvalidCommand);
Exit;
end;

s_:=StrAlloc(1024);
s_:=StrPCopy(s_,Name);
Old:=User.Name;
User.Name:=s_;
StrDispose(s_);
s.Add(Old+_MsgRename+User.Name)
end;

function Steal(s:TStringList):integer;export;
label sss;
begin
s.Clear;
result:=_Normal;

if not GameRun then begin
result:=_Warning;
s.Add(_MsgNewGame);
exit;
end else
if computer.healt=0 then begin
result:=_Normal;
s.Add(_MsgNothing);
exit;
end;

if FigthRun then goto sss;

if random(2)=1 then
  if user.StealFactor>(computer.Status) then begin
    if computer.Many=0 then begin
    s.Add(_MsgStealNOMany);
    exit;
    end;
  s.Add(Format(_MsgStealOK,[computer.Many]));
  Inc(user.Many,computer.Many);
  computer.Many:=0;
  result:=_OK;
  Exit;
  end else begin
  s.Add(_MsgStealWarning);
  FigthRun:=True;
  result:=_Warning;
  Exit;
  end;

sss:
s.Add(_MsgStealNO);//   
end;

function Shoop_(s:TStringList;tag:Byte):integer;
begin
s.Clear;
result:=_Normal;

if (user.healt = 0) or (not GameRun) then begin
result:=_Warning;
s.Add(_MsgNewGame);
exit;
end;

if FigthRun then begin
s.Add(_MsgCompNeedFigth2);
exit;
end;

result:=_Info;
if not Shoop.Active then begin //     
Shoop.Active:=true;
Shoop.Tag:=tag;
Shoop.Name:=TShoop_[tag];
case Shoop.Tag of
0:begin // 
  Shoop.Data[0].Name:=TThing_[0];//'  '
  Shoop.Data[0].Typeof:=ttThing;
  Shoop.Data[0].Value:=3;
  Shoop.Data[0].Cout:=1;
  Shoop.Data[0].price:=10;

  Shoop.Data[1].Name:=TThing_[1];// '  "Nike"'
  Shoop.Data[1].Typeof:=ttThing;
  Shoop.Data[1].Value:=10;
  Shoop.Data[1].Cout:=1;
  Shoop.Data[1].price:=30;

  Shoop.Data[2].Name:=TThing_[2];//'   '
  Shoop.Data[2].Typeof:=ttThing;
  Shoop.Data[2].Value:=15;
  Shoop.Data[2].Cout:=1;
  Shoop.Data[2].price:=35;

  end;
1:begin // 
  Shoop.Data[0].Name:=TDrunk_[0];//' ""'
  Shoop.Data[0].Typeof:=ttDrunk;
  Shoop.Data[0].Value:=2;
  Shoop.Data[0].Cout:=1;
  Shoop.Data[0].price:=5;

  Shoop.Data[1].Name:=TDrunk_[1];//''
  Shoop.Data[1].Typeof:=ttDrunk;
  Shoop.Data[1].Value:=7;
  Shoop.Data[1].Cout:=1;
  Shoop.Data[1].price:=10;

  Shoop.Data[2].Name:=TDrunk_[2];//''
  Shoop.Data[2].Typeof:=ttDrunk;
  Shoop.Data[2].Value:=9;
  Shoop.Data[2].Cout:=1;
  Shoop.Data[2].price:=25;

  end;
2:begin // 
  Shoop.Data[0].Name:=Clothes_[0];//' Aidepas'
  Shoop.Data[0].Typeof:=ttClothes;
  Shoop.Data[0].Value:=1;
  Shoop.Data[0].Cout:=1;
  Shoop.Data[0].price:=15;

  Shoop.Data[1].Name:=Clothes_[1];//'  Boss'
  Shoop.Data[1].Typeof:=ttClothes;
  Shoop.Data[1].Value:=4;
  Shoop.Data[1].Cout:=1;
  Shoop.Data[1].price:=20;

  Shoop.Data[2].Name:=Clothes_[2];//' Adidas'
  Shoop.Data[2].Typeof:=ttClothes;
  Shoop.Data[2].Value:=10;
  Shoop.Data[2].Cout:=1;
  Shoop.Data[2].price:=35;
  end;
end;
  s.Add(Shoop.Name+':');
  s.Add(Format(_Goods,[1,Shoop.Data[0].Name,Shoop.Data[0].price]));
  s.Add(Format(_Goods,[2,Shoop.Data[1].Name,Shoop.Data[1].price]));
  s.Add(Format(_Goods,[3,Shoop.Data[2].Name,Shoop.Data[2].price]));
end;
end;

function bar(s:TStringList):integer;export;//''
begin
result:=Shoop_(s,0);
end;

function lar(s:TStringList):integer;export;//''
begin
result:=Shoop_(s,1);
end;

function mag(s:TStringList):integer;export;//''
begin
result:=Shoop_(s,2);
end;

function buy(s:TStringList;Number:string):integer;export;//
var
  i:integer;
begin
if not Shoop.Active then exit;

if Number='' then begin
//result:=_Info;
s.Add(_MsgInvalidCommand);
Exit;
end;
if StrToInt(Number)>3 then exit;

if user.Many>=Shoop.Data[StrToInt(Number)-1].price then begin

for i:=0 to High(user.Thing) do
    if user.Thing[i].Name =Shoop.Data[StrToInt(Number)-1].Name then begin
    s.Add(_MsgBuyAlreadyExists);
    result:=_Info;
    exit;
    end;

dec(user.Many,Shoop.Data[StrToInt(Number)-1].price);
setlength(user.Thing,Length(user.Thing)+1);
user.Thing[High(user.Thing)]:=Shoop.Data[StrToInt(Number)-1];

s.Add(Format(_MsgBuyOK,[user.Thing[High(user.Thing)].Name]));
result:=_OK;
end else begin
s.Add(_MsgBuyNoMany);
result:=_Warning;
end;

end;

{
function LoadOptions(FileName:string):boolean;
begin
with TIniFile.Create( FileName ) do
  try
    ReadSectionValues( Section, Self);
    for Index:= 0 to Count - 1 do
    begin
    Line:= Values[ IntToStr( Index ) ];
    System.Delete( Line, 1, 1);
    Strings[ Index ]:= Line;
    end;
  finally
    Free;
end;

end;

function Start(FileName:string):boolean;
begin
LoadOptions(_FileOptions);
end;
}
exports
  GetCommandPromt name 'GetCommandPromt',
  Fighting name 'f',
  GetUserInfo name 'i',
  GetCompInfo name 'c',
  Steal name 's',// -    
  Going name 'g',
  Help name 'h',
  NewGame name 'n',
  DrinkBeer name 'd',
  Rename name 'r',
  bar name 'bar',
  lar name 'lar',
  mag name 'mag',
  buy name 'buy';
begin
end.
